Unit Komplex;

Interface
Uses Okna;
type Complex = record
                Re : Extended;
                Im : Extended;
               end;

var chyba:boolean;
    Code: Integer;

Function Re(Num:Complex):Extended;
procedure Err;
Function Im(Num:Complex):Extended;
Function Rad2St(Rad:Extended):Extended;
Function St2Rad(St:Extended):Extended;
Procedure Disp_sl(Num:Complex);
Function Vel(Num:Complex):Extended;
Function Uh(Num:Complex):Extended;
Procedure Disp_ex(Num:Complex);
Function ex2sl_Re(Vel,Uh:Extended):Extended;
Function ex2sl_Im(Vel,Uh:Extended):Extended;
Function Slozka(s:string):boolean;
Function Str_Sl2Sl_Re(s:string):Extended;
Function Str_Sl2Sl_Im(s:string):Extended;
Function Str_Ex2Sl_Vel(s:string):Extended;
Function Str_Ex2Sl_Uh(s:string):Extended;
Function Delit_Re(Num1,Num2:Complex):Extended;
Function Delit_Im(Num1,Num2:Complex):Extended;
Function Nasobit_Re(Num1,Num2:Complex):Extended;
Function Nasobit_Im(Num1,Num2:Complex):Extended;
Function SinHyp_Re(Num:Complex):Extended;
Function SinHyp_Im(Num:Complex):Extended;
Function CosHyp_Re(Num:Complex):Extended;
Function CosHyp_Im(Num:Complex):Extended;
Function TgHyp_Re(Num:Complex):Extended;
Function TgHyp_Im(Num:Complex):Extended;
Function sl2ex_vel(Num:Complex):extended;
Function Sl2Ex_uh(Num:Complex):extended;
Function odmocnina_re(Num:Complex):Extended;
Function odmocnina_im(Num:Complex):Extended;


Implementation
Uses Crt, Dos;

{================= P R O C E D U R Y   A   F U N K C E ======================}
Function Re(Num:Complex):Extended;
 Begin
 Re:=Num.Re;
 End;

procedure Err;
begin
 if code<>0 then write(chr(7));
end;

Function Im(Num:Complex):Extended;
 Begin
 Im:=Num.Im;
 End;

Function Rad2St(Rad:Extended):Extended;
 Begin
  Rad2St:=Rad/Pi*180;
 End;

Function St2Rad(St:Extended):Extended;
 Begin
  St2Rad:=St/180*Pi;
 End;

Procedure Disp_sl(Num:Complex);
var zn:string;
 Begin
 if Im(num)<0 then zn:='-'
              else zn:='+';
 Write(Re(Num),' ');
 textcolor(white);write(zn);
 textcolor(lightgreen);write(' ',abs(Im(Num)));
 textcolor(black);write(' j');
 End;

Function Vel(Num:Complex):Extended;
 Begin
 Vel:=sqrt(sqr(Re(num))+sqr(Im(Num)));
 End;

Function Uh(Num:Complex):Extended;
var pom:extended;
begin
pom:=arctan(abs(num.im)/abs(num.re));
pom:=rad2st(pom);
if (num.re>0) and (num.im<0) then pom:=-pom;
if (num.re<0) and (num.im>0) then pom:=180-pom;
if (num.re<0) and (num.im<0) then pom:=-180+pom;
uh:=pom;
end;

Procedure Disp_ex(Num:Complex);
 Begin
  Write(Vel(Num):5:5,'e^',Uh(Num):3:3)
 End;

Function ex2sl_Re(Vel,Uh:Extended):Extended;
 Begin
 uh:=st2rad(uh);
 ex2sl_Re:=Vel*cos(Uh)
 End;

Function ex2sl_Im(Vel,Uh:Extended):Extended;
 Begin
 uh:=st2rad(uh);
 ex2sl_Im:=Vel*sin(Uh)
 End;

Function Slozka(s:string):boolean;
begin
slozka:=true;
if (pos('e',s)>0) or (pos('E',s)>0) then slozka:=false
end;


Function Str_Sl2Sl_Re(s:string):Extended;
var s1,s2:string;
    n:integer;
    r1,r2:extended;
Begin
  s:=odmezer1(s);
{  if (pos('+',s)=0) and (pos('-',s)=0) then s:='+'+s;}
  n:=1;s1:='';s2:='';
  if s[1]='-' then begin s1:='-';s:=copy(s,2,length(s)-1);end;
  while (ord(s[n]) in [48..57]) or (ord(s[n]) = 46) do
   begin
    s1:=s1+s[n];n:=n+1;
   end;
  if s1='' then s1:='0';
  s2:=copy(s,n,length(s)-n);if s2='' then s2:='0';
  val(s1,r1,code);if code<>0 then chyba:=true;
  val(s2,r2,code);if code<>0 then chyba:=true;
  Str_Sl2Sl_Re:=r1;
End;

Function Str_Sl2Sl_Im(s:string):Extended;
var s1,s2:string;
    n:integer;
    r1,r2:extended;
Begin
  s:=odmezer1(s);
{  if (pos('+',s)=0) and (pos('-',s)=0) then s:='+'+s;}
  n:=1;s1:='';s2:='';
  if s[1]='-' then begin s1:='-';s:=copy(s,2,length(s)-1);end;
  while (ord(s[n]) in [48..57]) or (ord(s[n]) = 46) do
   begin
    s1:=s1+s[n];n:=n+1;
   end;
  if s1='' then s1:='0';
  s2:=copy(s,n,length(s)-n);if s2='' then s2:='0';
  val(s1,r1,code);if code<>0 then chyba:=true;
  val(s2,r2,code);if code<>0 then chyba:=true;
  Str_Sl2Sl_Im:=r2;
End;

Function Str_Ex2Sl_Vel(s:string):Extended;
var s1,s2:string;
    n:integer;
    r1,r2:extended;
Begin
  s:=odmezer1(s);n:=1;s1:='';s2:='';
{  if (pos('+',s)=0) and (pos('-',s)=0) then s:='+'+s;}
  if s[1]='-' then begin s1:='-';s:=copy(s,2,length(s)-1);end;
  while (ord(s[n]) in [48..57]) or (ord(s[n]) = 46) do
   begin
    s1:=s1+s[n];n:=n+1;
   end;
  n:=n+2;
  if s1='' then s1:='0';
  s2:=copy(s,n,length(s)-n+1);if s2='' then s2:='0';
  val(s1,r1,code);if code<>0 then chyba:=true;
  val(s2,r2,code);if code<>0 then chyba:=true;
  Str_Ex2Sl_Vel:=r1;
End;

Function Str_Ex2Sl_Uh(s:string):Extended;
var s1,s2:string;
    n:integer;
    r1,r2:extended;
Begin
  s:=odmezer1(s);
{  if (pos('+',s)=0) and (pos('-',s)=0) then s:='+'+s;}
  n:=1;s1:='';s2:='';
  if s[1]='-' then begin s1:='-';s:=copy(s,2,length(s)-1);end;
  while (ord(s[n]) in [48..57]) or (ord(s[n]) = 46) do
   begin
    s1:=s1+s[n];n:=n+1;
   end;
  n:=n+2;
  if s1='' then s1:='0';
  s2:=copy(s,n,length(s)-n+1);if s2='' then s2:='0';
  val(s1,r1,code);if code<>0 then chyba:=true;
  val(s2,r2,code);if code<>0 then chyba:=true;
  Str_Ex2Sl_Uh:=r2;
End;


Function Delit_Re(Num1,Num2:Complex):Extended;
Var N1_V,N1_U,N2_V,N2_U,Vysl_V,Vysl_U,pom:Extended;
 Begin
  N1_V:=Vel(Num1);N1_U:=Uh(Num1);N2_V:=Vel(Num2);N2_U:=Uh(Num2);
  Vysl_V:=N1_V/N2_V;Vysl_U:=N1_U-N2_U;
  pom:=ex2sl_Re(Vysl_V,Vysl_U);
  Delit_Re:=pom;
 End;

Function Delit_Im(Num1,Num2:Complex):Extended;
Var N1_V,N1_U,N2_V,N2_U,Vysl_V,Vysl_U:Extended;
 Begin
  N1_V:=Vel(Num1);N1_U:=Uh(Num1);N2_V:=Vel(Num2);N2_U:=Uh(Num2);
  Vysl_V:=N1_V/N2_V;Vysl_U:=N1_U-N2_U;
  Delit_Im:=ex2sl_Im(Vysl_V,Vysl_U);
 End;

Function Nasobit_Re(Num1,Num2:Complex):Extended;
 Begin
  Nasobit_Re:=Num1.Re*Num2.Re-Num1.Im*Num2.Im
 End;

Function Nasobit_Im(Num1,Num2:Complex):Extended;
 Begin
  Nasobit_Im:=Num1.Re*Num2.Im+Num1.Im*Num2.Re
 End;

Function SinHyp_Re(Num:Complex):Extended;
Var a,b:Extended;
 Begin
   a:=Re(Num);b:=Im(Num);
   SinHyp_Re:=((exp(a)/2)*cos(b)-1/(2*exp(a))*cos(-b));
 End;

Function SinHyp_Im(Num:Complex):Extended;
Var a,b:Extended;
 Begin
   a:=Re(Num);b:=Im(Num);
   SinHyp_Im:=((exp(a)/2)*sin(b)-1/(2*exp(a))*sin(-b));
 End;

Function CosHyp_Re(Num:Complex):Extended;
Var a,b:Extended;
 Begin
   a:=Re(Num);b:=Im(Num);
   CosHyp_Re:=((exp(a)/2)*cos(b)+1/(2*exp(a))*cos(-b));
 End;

Function CosHyp_Im(Num:Complex):Extended;
Var a,b:Extended;
 Begin
   a:=Re(Num);b:=Im(Num);
   CosHyp_Im:=((exp(a)/2)*sin(b)+1/(2*exp(a))*sin(-b));
 End;

Function TgHyp_Re(Num:Complex):Extended;
Var a,b,c,d:Extended;
 Begin
  a:=SinHyp_Re(Num);
  b:=SinHyp_Im(Num);
  c:=CosHyp_Re(Num);
  d:=CosHyp_Im(Num);
  TgHyp_Re:=(a*c+b*d)/(c*c+d*d);
 End;

Function TgHyp_Im(Num:Complex):Extended;
Var a,b,c,d:Extended;
 Begin
  a:=SinHyp_Re(Num);
  b:=SinHyp_Im(Num);
  c:=CosHyp_Re(Num);
  d:=CosHyp_Im(Num);
  TgHyp_Im:=(b*c-a*d)/(c*c+d*d);
 End;

Function sl2ex_vel(Num:Complex):extended;
var pom1,pom2,pom,pom3:extended;
begin
pom1:=num.re*num.re;
pom2:=num.im*num.im;
pom:=pom1+pom2;
pom3:=sqrt(pom);
sl2ex_vel:=pom3;
end;

Function Sl2Ex_uh(Num:Complex):extended;
var uh:extended;
begin
uh:=arctan(abs(num.im)/abs(num.re));
uh:=rad2st(uh);
if (num.re>0) and (num.im<0) then uh:=-uh;
if (num.re<0) and (num.im>0) then uh:=180-uh;
if (num.re<0) and (num.im<0) then uh:=-180+uh;
sl2ex_uh:=uh;
end;


Function odmocnina_re(Num:Complex):Extended;
var vel,uh,pom:extended;
begin
vel:=sl2ex_vel(num);
uh:=sl2ex_uh(num);
uh:=uh/2;
vel:=sqrt(vel);
pom:=ex2sl_re(vel,uh);
odmocnina_re:=ex2sl_re(vel,uh);
end;


Function odmocnina_im(Num:Complex):Extended;
var vel,uh,pom:extended;
begin
vel:=sl2ex_vel(num);
uh:=sl2ex_uh(num);
uh:=uh/2;
vel:=sqrt(vel);
pom:=ex2sl_im(vel,uh);
odmocnina_im:=pom;
end;


begin
end.